%{

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "strfunc.h"

int sf_cfg_i_nline=0;
int yylex();
int yyerror(char *);

slist *sf_cfg_i_a;
slist *sf_cfg_i_v;

%}

/*
 * Token value definition
 */
%union {
	char *tv_char;
	slist *tv_slist;
}

/*
 * Token types returned by scanner
 */
%token	<tv_char>	TOK_STRING
%type	<tv_slist>	Attrs

/*
 * Reserved words
 */
%token				EQ
%token				LB
%token				RB
%token				COMMA
%token				COLON
%token				SEMICOLON

%%
cfg_file:
	| sequence;

sequence: block
	| sequence block
	;

eq:
	| EQ
	;

ps:
	| SEMICOLON
	;

cs:
	| COMMA
	;

block:
	TOK_STRING eq TOK_STRING ps {
		if(!sf_cfg_i_a) {
			sf_cfg_i_a=sinit();
			sf_cfg_i_v=sinit();
		};

		sadd_attach(sf_cfg_i_a, $1, strlen($1));
		sadd_attach(sf_cfg_i_v, $3, strlen($3));
	}
	| TOK_STRING eq LB Attrs RB ps {
		int i;

		if(!sf_cfg_i_a) {
			sf_cfg_i_a=sinit();
			sf_cfg_i_v=sinit();
		};

		for(i=0; i< ((slist *)$4)->count; i++) {
			sadd(sf_cfg_i_a, $1);
			sadd(sf_cfg_i_v, ((slist *)$4)->list[i]);
		};
		free($1);
		sfree((slist *)$4);
	}
	;

Attrs:
	TOK_STRING {
		$$=sinit();
		sadd_attach($$, $1, strlen($1));
	}
	| Attrs cs TOK_STRING {
		sadd_attach($1, $3, strlen($3));
	};

%%

int
yyerror(char *s) {
	fprintf(stderr, "Config parse error near line %d: %s\n", sf_cfg_i_nline+1, s);
	return 0;
};
