#include <stdio.h>
#include <stdlib.h>
#include <sysexits.h>

#ifdef	HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef	HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <strfunc.h>

void check(char *, char *);

int main(int ac, char **av) {

	check("s/(word)/s\\1/i", "He bought a word and said a word.");
	check("s/(word)/s\\1/ig", "He bought a word and put this word.");
	check("s/(tree) (apple)/\\2 \\1/igr", "Tree Apple goose");
	check("s/tree apple/sdf/i", "Tree Apple mixed");
	check("y/abc/AbC/i", "aBcabc");
	check("/apple/i", "another apple tree");
	check("/aple/i", "another apple tree");
	check("/apple/yes!/i", "another apple tree");
	check("/tree$/yes!/i", "another apple tree");
	check("/t(re)e/yes!/i", "another apple tree");
	check("/([0-9])/i", "celeron-400");
	check("/([0-9])/i", "celeron");
	check("/([0-9])/ie", "celeron-400");
	check("/([0-9])/ie", "celeron");
	check("/([0-9])/\\1/i", "celeron-400");
	check("/([0-9])/\\1/ir", "celeron");
	check("/-([0-9]+)/\\1/ier", "celeron-400");
	check("/([0-9]+)/\\1/ier", "celeron");
	check("/^[;:])([0-9]*)[@]*$/rei", ":)2");
	check("/ab /reig", "xxx Ab xxx aB xxx");
	check("/ab /reign", "xxx Ab xxx aB xxx");
	check("/(ab) /reig", "xxx Ab xxx aB xxx");
	check("/(ab) /reign", "xxx Ab xxx aB xxx");
	check("s/tree apple/[\\0]/i", "Tree Apple mixed");
	check("s/=([0-9])=/=z=/ge", "=0= =2= =3=");
	check("s/(=[0-9]= )+/=z=/re", "=0= =2= =3=");

	return 0;
};

void
check(char *expr, char *ag) {
	sed_t *se;
	slist *sl;
	char *r;

	printf("\n");
	printf("Checking expression:\n");
	printf("[%s] against [%s]\n", expr, ag);

	se=sed_compile(expr);

	if(!se) {
		printf("Compile FAILED!\n");
		return;
	};

	r = sed_exec(se, ag);
	printf("Result: [%s]\n", r?r:"<NULL>");

	if((sl = sed_results(se)))
		printf("sed_results: [%s]\n", sjoin(sl, "], ["));

	sed_free(se);
};
